Subject: Re: consistent ioctl for getting all net interfaces?

From: Olaf Hering <[email-masked]>
Date: Sun, 30 May 2004 22:25:08 +0200

On Sat, May 22, Joshua Kwan wrote:

> Hi,
> 
> I'm interested in not having to parse /proc/net/dev to get a list of all
> available (not necessarily even up) interfaces on the system. I
> investigated the ioctl SIOCGIFCONF, but it seems to behave differently on
> 2.4 and 2.6 series kernels, e.g. sometimes it won't return all interfaces.

you should bring that to [email-masked] instead of lkml.

IF the ioctl has really changed, then it would be a bug. I just played
with ipconfig from the klibc distribution, and it returns only
interfaces in UP state. I'm sure that ipconfig binary worked when the
code was written.

If the ioctl is supposed to work how it does in 2.6, there is still
/sys/class/net/*. Thats (probably) more reliable than a text parser.
See `nameif -r 'foo: bar' eth0` as example.

-- 
USB is for mice, FireWire is for men!

sUse lINUX ag, nÜRNBERG